////////////////////////////////////////////////////////////////////////////////
//    Scorched3D (c) 2000-2011
//
//    This file is part of Scorched3D.
//
//    Scorched3D is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    Scorched3D is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License along
//    with this program; if not, write to the Free Software Foundation, Inc.,
//    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
////////////////////////////////////////////////////////////////////////////////

#if !defined(__INCLUDE_ServerTurnsSimultaneoush_INCLUDE__)
#define __INCLUDE_ServerTurnsSimultaneoush_INCLUDE__

#include <map>
#include <list>
#include <server/ServerTurns.h>
#include <engine/SimulatorI.h>

class Tank;
class ComsPlayedMoveMessage;
class ServerTurnsSimultaneous : public ServerTurns
{
public:
	ServerTurnsSimultaneous(bool waitForShots);
	virtual ~ServerTurnsSimultaneous();

	virtual void internalEnterState();
	virtual void internalSimulate(fixed frameTime);
	virtual void internalMoveFinished(ComsPlayedMoveMessage &playedMessage);
	virtual void internalShotsFinished();

protected:
	ShotsState shotsState_;
	unsigned int nextMoveId_;
	fixed waitingTime_;
	std::map<unsigned int, ComsPlayedMoveMessage*>  moves_;
};

#endif
